import UIKit
import Flutter

import ZendeskSDK
import ZendeskCoreSDK

@UIApplicationMain

@objc class AppDelegate: FlutterAppDelegate {
    var _result: FlutterResult!

    var FLUTTER_CHANNEL = "flutter_zendesk"
    var controller : FlutterViewController?


  override func application(
    _ application: UIApplication,
    didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?
  ) -> Bool {
    print("heyyy")
    
    GeneratedPluginRegistrant.register(with: self)
    
    guard let flutterViewController  = window?.rootViewController as? FlutterViewController else {
        return super.application(application, didFinishLaunchingWithOptions: launchOptions)
    }
    let flutterChannel = FlutterMethodChannel.init(name: "flutter_zendesk", binaryMessenger: flutterViewController as! FlutterBinaryMessenger);

    flutterChannel.setMethodCallHandler {(flutterMethodCall, flutterResult) in
        if flutterMethodCall.method.elementsEqual("initiate"){
         
            
                print("launch zendesk")
                
                let args = flutterMethodCall.arguments as? NSDictionary
                
                let appId = args!["appId"]as? String
                let clientId  = args!["clientId"]as? String
                let url = args!["url"]as? String
                
                Zendesk.initialize(appId: appId!,
                                   clientId: clientId!,
                                   zendeskUrl: url!)
                Support.initialize(withZendesk: Zendesk.instance)
                
                let ident = Identity.createAnonymous()
                Zendesk.instance?.setIdentity(ident)
                
                let hcConfig = HelpCenterUiConfiguration()
                hcConfig.groupType = .section
                hcConfig.groupIds = [1234, 5678]
                let helpCenter = HelpCenterUi.buildHelpCenterOverviewUi(withConfigs: [hcConfig])
                
                self.window?.rootViewController = nil
                let navigationController = UINavigationController(rootViewController: flutterViewController)
                
                self.window = UIWindow(frame: UIScreen.main.bounds)
                self.window?.makeKeyAndVisible()
                self.window.rootViewController = navigationController
                navigationController.isNavigationBarHidden = false
        
                navigationController.pushViewController(helpCenter, animated: true)
                
            
        

        }
    }
        return super.application(application, didFinishLaunchingWithOptions: launchOptions)
  }
    }

